From 19408d1d58f391dfbb13d76c3b46e553b0d4ec4d Mon Sep 17 00:00:00 2001
From: Mark Dilger <mark.dilger@enterprisedb.com>
Date: Thu, 6 Feb 2020 11:41:44 -0800
Subject: [PATCH v5] Migrating commandTag from string to enum.
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

The backend was using strings to represent command tags and doing string
comparisons in multiple places.  Fixing that by creating a new
CommandTag enum and using it instead.

Replacing numerous occurrences of char *completionTag with a
QueryCompletionData struct so that the code no longer stores information
about completed queries in a cstring.  Only at the last moment, in
EndCommand(), does this get converted to a string.

EventTriggerCacheItem no longer holds an array of palloc’d tag strings
in sorted order, but rather just a Bitmapset over the CommandTags.
---
 .../pg_stat_statements/pg_stat_statements.c   |  18 +-
 contrib/sepgsql/hooks.c                       |   6 +-
 src/backend/catalog/DataFile.pm               | 400 ++++++++
 src/backend/commands/createas.c               |  14 +-
 src/backend/commands/event_trigger.c          | 160 +--
 src/backend/commands/matview.c                |   2 +-
 src/backend/commands/portalcmds.c             |  16 +-
 src/backend/commands/prepare.c                |   4 +-
 src/backend/executor/execMain.c               |   4 +-
 src/backend/executor/functions.c              |   4 +-
 src/backend/executor/spi.c                    |  22 +-
 src/backend/replication/walsender.c           |  18 +-
 src/backend/tcop/dest.c                       |  38 +-
 src/backend/tcop/postgres.c                   |  24 +-
 src/backend/tcop/pquery.c                     | 111 +--
 src/backend/tcop/utility.c                    | 558 +++++------
 src/backend/utils/.gitignore                  |   3 +
 src/backend/utils/Makefile                    |  20 +-
 src/backend/utils/cache/evtcache.c            |  27 +-
 src/backend/utils/cache/plancache.c           |   4 +-
 src/backend/utils/commandtag.c                | 119 +++
 src/backend/utils/gencommandtag.pl            | 266 +++++
 src/backend/utils/mmgr/portalmem.c            |   6 +-
 src/include/Makefile                          |   4 +-
 src/include/commands/createas.h               |   3 +-
 src/include/commands/event_trigger.h          |   2 +-
 src/include/commands/matview.h                |   2 +-
 src/include/commands/portalcmds.h             |   3 +-
 src/include/commands/prepare.h                |   2 +-
 src/include/nodes/parsenodes.h                |   1 +
 src/include/tcop/dest.h                       |   7 +-
 src/include/tcop/pquery.h                     |   2 +-
 src/include/tcop/utility.h                    |  15 +-
 src/include/utils/.gitignore                  |   2 +
 src/include/utils/commandtag.dat              | 938 ++++++++++++++++++
 src/include/utils/commandtag.h                |  60 ++
 src/include/utils/evtcache.h                  |   3 +-
 src/include/utils/plancache.h                 |   7 +-
 src/include/utils/portal.h                    |   6 +-
 src/pl/plpgsql/src/pl_exec.c                  |  10 +-
 .../test_ddl_deparse/test_ddl_deparse.c       |   2 +-
 src/tools/msvc/Solution.pm                    |  12 +
 42 files changed, 2311 insertions(+), 614 deletions(-)
 create mode 100644 src/backend/catalog/DataFile.pm
 create mode 100644 src/backend/utils/commandtag.c
 create mode 100755 src/backend/utils/gencommandtag.pl
 create mode 100644 src/include/utils/commandtag.dat
 create mode 100644 src/include/utils/commandtag.h

diff --git a/contrib/pg_stat_statements/pg_stat_statements.c b/contrib/pg_stat_statements/pg_stat_statements.c
index e0dbeebde3..1f3e9c1041 100644
--- a/contrib/pg_stat_statements/pg_stat_statements.c
+++ b/contrib/pg_stat_statements/pg_stat_statements.c
@@ -307,7 +307,7 @@ static void pgss_ExecutorEnd(QueryDesc *queryDesc);
 static void pgss_ProcessUtility(PlannedStmt *pstmt, const char *queryString,
 								ProcessUtilityContext context, ParamListInfo params,
 								QueryEnvironment *queryEnv,
-								DestReceiver *dest, char *completionTag);
+								DestReceiver *dest, QueryCompletion *qc);
 static uint64 pgss_hash_string(const char *str, int len);
 static void pgss_store(const char *query, uint64 queryId,
 					   int query_location, int query_len,
@@ -960,7 +960,7 @@ static void
 pgss_ProcessUtility(PlannedStmt *pstmt, const char *queryString,
 					ProcessUtilityContext context,
 					ParamListInfo params, QueryEnvironment *queryEnv,
-					DestReceiver *dest, char *completionTag)
+					DestReceiver *dest, QueryCompletion *qc)
 {
 	Node	   *parsetree = pstmt->utilityStmt;
 
@@ -998,11 +998,11 @@ pgss_ProcessUtility(PlannedStmt *pstmt, const char *queryString,
 			if (prev_ProcessUtility)
 				prev_ProcessUtility(pstmt, queryString,
 									context, params, queryEnv,
-									dest, completionTag);
+									dest, qc);
 			else
 				standard_ProcessUtility(pstmt, queryString,
 										context, params, queryEnv,
-										dest, completionTag);
+										dest, qc);
 		}
 		PG_FINALLY();
 		{
@@ -1013,10 +1013,8 @@ pgss_ProcessUtility(PlannedStmt *pstmt, const char *queryString,
 		INSTR_TIME_SET_CURRENT(duration);
 		INSTR_TIME_SUBTRACT(duration, start);
 
-		/* parse command tag to retrieve the number of affected rows. */
-		if (completionTag &&
-			strncmp(completionTag, "COPY ", 5) == 0)
-			rows = pg_strtouint64(completionTag + 5, NULL, 10);
+		if (qc && qc->commandTag == COMMANDTAG_COPY)
+			rows = qc->nprocessed;
 		else
 			rows = 0;
 
@@ -1060,11 +1058,11 @@ pgss_ProcessUtility(PlannedStmt *pstmt, const char *queryString,
 		if (prev_ProcessUtility)
 			prev_ProcessUtility(pstmt, queryString,
 								context, params, queryEnv,
-								dest, completionTag);
+								dest, qc);
 		else
 			standard_ProcessUtility(pstmt, queryString,
 									context, params, queryEnv,
-									dest, completionTag);
+									dest, qc);
 	}
 }
 
diff --git a/contrib/sepgsql/hooks.c b/contrib/sepgsql/hooks.c
index 997a64c87e..853b5b04ab 100644
--- a/contrib/sepgsql/hooks.c
+++ b/contrib/sepgsql/hooks.c
@@ -317,7 +317,7 @@ sepgsql_utility_command(PlannedStmt *pstmt,
 						ParamListInfo params,
 						QueryEnvironment *queryEnv,
 						DestReceiver *dest,
-						char *completionTag)
+						QueryCompletion *qc)
 {
 	Node	   *parsetree = pstmt->utilityStmt;
 	sepgsql_context_info_t saved_context_info = sepgsql_context_info;
@@ -380,11 +380,11 @@ sepgsql_utility_command(PlannedStmt *pstmt,
 		if (next_ProcessUtility_hook)
 			(*next_ProcessUtility_hook) (pstmt, queryString,
 										 context, params, queryEnv,
-										 dest, completionTag);
+										 dest, qc);
 		else
 			standard_ProcessUtility(pstmt, queryString,
 									context, params, queryEnv,
-									dest, completionTag);
+									dest, qc);
 	}
 	PG_FINALLY();
 	{
diff --git a/src/backend/catalog/DataFile.pm b/src/backend/catalog/DataFile.pm
new file mode 100644
index 0000000000..f7bf7656fc
--- /dev/null
+++ b/src/backend/catalog/DataFile.pm
@@ -0,0 +1,400 @@
+#!/usr/bin/perl -w
+#----------------------------------------------------------------------
+# DataFile.pm
+#    Perl module that safely converts data files into perl data.
+#
+# Portions Copyright (c) 1996-2020, PostgreSQL Global Development Group
+# Portions Copyright (c) 1994, Regents of the University of California
+#
+# src/backend/catalog/DataFile.pm
+#
+#----------------------------------------------------------------------
+
+
+=pod
+
+=head1 NAME
+
+DataFile - module for safely parsing and vivifying perl data files
+
+=head1 SYNOPSIS
+
+  use DataFile;
+
+  my $array_reference = DataFile::ParseData("myfile.dat");
+
+=head1 DESCRIPTION
+
+DataFile contains a parsing function, ParseData, for parsing various
+data files.  By convention, these data files are stored as a single array
+of hashes of key/value pairs.
+
+=pod
+
+=head1 METHODS
+
+=cut
+
+package DataFile;
+
+use strict;
+use warnings;
+use Config;
+
+=pod
+
+=over
+
+=item slurp_file(filename)
+
+Return the full contents of the specified file.
+
+=cut
+
+sub slurp_file
+{
+	my ($filename) = @_;
+	local $/;
+	my $contents;
+	if ($Config{osname} ne 'MSWin32')
+	{
+		open(my $in, '<', $filename)
+		  or die "could not read \"$filename\": $!";
+		$contents = <$in>;
+		close $in;
+	}
+	else
+	{
+		my $fHandle = createFile($filename, "r", "rwd")
+		  or die "could not open \"$filename\": $^E";
+		OsFHandleOpen(my $fh = IO::Handle->new(), $fHandle, 'r')
+		  or die "could not read \"$filename\": $^E\n";
+		$contents = <$fh>;
+		CloseHandle($fHandle)
+		  or die "could not close \"$filename\": $^E\n";
+	}
+	$contents =~ s/\r//g if $Config{osname} eq 'msys';
+	return $contents;
+}
+
+=pod
+
+=item ParseData(filename)
+
+Parse a file which represents a valid perl array reference of hash references,
+vivify the perl array reference, and return it.
+
+This function is paranoid about evaluation or interpolation of embedded perl
+and will die with an error message if the file contains anything that looks
+like it will result in code being executed.
+
+Mistakes in the data file making it an invalid perl object will draw errors
+about the line number in the file where parsing failed and an attempt to
+indicate what parsing problem was encountered there.
+
+=cut
+
+our (%looking, $pos);
+sub update_search($$)
+{
+	my ($lookingfor, $atpos) = @_;
+	if ($atpos > $pos)
+	{
+		%looking = ($lookingfor => 1);
+		$pos = $atpos;
+	}
+	elsif ($atpos == $pos)
+	{
+		$looking{$lookingfor} = 1;
+	}
+}
+
+sub ParseData
+{
+	my ($inputfile) = @_;
+
+	# Vivify the input data, but be paranoid about eval'ing arbitrary code
+	my $data;
+	eval {
+		my $untrusted = slurp_file($inputfile);
+		our $noeval = undef;
+		our $noevalstr = undef;
+		our $noevalpos = -1;
+		%looking = ();
+		$pos = -1;
+
+		# A quotable string is one that does not embed an unescaped end-quote
+		# or end with a backslash which would escape the quote that otherwise
+		# terminates the quoted string.
+		my $singlequotablere = qr/
+								# Verify through look-behind that we're at the
+								# beginning of a single-quoted string
+								(?<=')
+								# Consume the single-quoted string contents
+								# without backtracking or givebacks.
+								(?>
+									# Any single character except single-quote
+									# or backslash
+									[^'\\]
+									|
+									# Any escaped character, including escaped
+									# single-quotes and escaped backslashes
+									\\.
+								)*+
+								# Verify through look-ahead that we're at the
+								# end of a single-quoted string
+								(?=')
+							/msx;
+
+		# Inside double-quoted strings, Perl interpolates substrings which look
+		# like variables with those variables' values.  This seems a bit unsafe
+		# to allow in this package, so we check double-quoted strings for
+		# anything that Perl might interpret this way at 'eval' time.  Such
+		# substrings still match our pattern, but we set a flag alerting us to
+		# not proceed to interpolate the substring.
+		my $doublequotablere = qr/
+								# Verify through look-behind that we're at the
+								# beginning of a double-quoted string
+								(?<=")
+								# Begin capturing.  If we encounter an illegal
+								# sequence, we can save the captured string for
+								# use later during error reporting
+								(
+								# Consume the double-quoted string contents
+								# without backtracking or givebacks.
+								(?>
+									# Any character except double-quote,
+									# backslash, or variable indicators [$%@]
+									[^"\\%@\$]
+									|
+									# Any escaped character
+									\\.
+									|
+									# A variable indicator, but we set the flag
+									# that we must not eval this string
+									[%@\$](?{ local $noeval = 1; })
+								)*+
+								# verify through look-ahead that we're at the
+								# end of the double-quoted string
+								(?=")
+								# End capture
+								)
+								# If we encountered a disallowed character
+								# during the capture, record the entire captured
+								# string for later
+								(?{ $noevalstr = $^N, $noevalpos = pos()
+										if ($noeval && !defined $noevalstr);
+								  })
+							/msx;
+
+		my $quotedstringre = qr/
+							(?:
+								'
+								(?{ update_search("end of single quoted string", pos()) })
+								$singlequotablere
+								'
+								|
+								"
+								(?{ update_search("end of double quoted string", pos()) })
+								$doublequotablere
+								"
+							)
+							/msx;
+
+		# A perl comment cannot occur inside a quoted string, but otherwise it can
+		# occur pretty much anywhere.  So long as we're not inside a quotation, we
+		# can match a # to the end of the line
+		my $commentre = qr/
+							(?:
+								(?{ update_search("comment", pos()) })
+								# Beginning of a comment
+								\#
+								# Anything other than end-of-line, no backtracking,
+								# and no give-backs
+								(?>[^\r\n])*+
+								# end-of-line
+								\r?\n
+							)
+						/msx;
+
+		# Comments and/or whitespace can occur just about anywhere.  It is convenient
+		# to have a single regex that matches them so we don't have to think about
+		# comments much from here onward.
+		my $spacere = qr/
+						(?:
+							# any number of comment lines, including none, including
+							# leading whitespace before the comment begins
+							(?:
+								(?{ update_search("whitespace", pos()) })
+								(?>\s)*+	# whitespace without backtracking
+								(?{ update_search("comment", pos()) })
+								$commentre
+							)*+
+							# whitespace following the zero or more comment lines,
+							# without backtracking
+							(?{ update_search("whitespace", pos()) })
+							(?>\s)*+
+						)
+						/msx;
+
+		# Keys must be either quoted strings, numbers, or barewords if followed
+		# by an arrow operator.  The arrow operator is not part of the key, however,
+		# so we check that with a look-ahead assertion
+		my $keyre = qr/
+						(?:
+							$quotedstringre
+							|
+							\d+
+							|
+							# bareword only allowed before arrow op, but there cannot
+							# be comments inbetween, only whitespace
+							\w+(?=\s*=>)
+						)
+					/msx;
+		# Values must be either numbers or quoted strings
+		my $valuere = qr/
+							(?:
+								$quotedstringre
+								|
+								\d+
+							)
+						/msx;
+
+		# Key/Value pairs can use arrow or comma separators.  We hid the complexity
+		# of arrow operator quoting in the keyre, above
+		my $keyvaluere = qr/
+							(?{ update_search("key value pair", pos()) })
+							(?:
+								$keyre
+								$spacere
+								(?:
+									=>
+									|
+									,
+								)
+								$spacere
+								$valuere
+							)
+							/msx;
+
+		# Key/Value pair lists
+		my $keyvaluelistre = qr/
+									# Optional key-value pair
+									(?:
+										$keyvaluere
+										$spacere
+
+										# Optionally followed by more
+										(?:
+											,		# Required
+											$spacere
+											$keyvaluere
+										)*
+										# Optionally ending with a comma
+										(?:
+											$spacere
+											,
+										)?
+									)?
+								/msx;
+
+		# Hash reference comprised of key/value pairs
+		my $hashrefre = qr/
+								(?:
+									(?{ update_search("beginning of hash reference", pos()) })
+									\{		# Open hash
+									$spacere
+									$keyvaluelistre
+									$spacere
+									(?{ update_search("ending of hash reference", pos()) })
+									\}		# Close hash
+								)
+							/msx;
+
+		# List of hash references
+		my $hashreflist = qr/
+								# Optional hash ref
+								(?:
+									$hashrefre
+									$spacere
+
+									# Optionally followed by more
+									(?:
+										,		# Required
+										$spacere
+										$hashrefre
+									)*+
+									# Optionally ending with a comma
+									(?:
+										$spacere
+										,
+									)?+
+								)?+
+							/msx;
+
+		# Reference to list of hash references
+		my $aryofhashrefre = qr/
+								(?:
+									(?{ update_search("beginning of array reference", pos()) })
+									\[		# Open array
+									$spacere
+									$hashreflist
+									$spacere
+									(?{ update_search("ending of array reference", pos()) })
+									\]		# Close array
+								)
+								/msx;
+
+
+		# After removing all comments, remaining structure must strictly
+		# match an array reference of hash references of key/value pairs
+		# with no code that perl's eval() could be tricked into running.
+		#
+		# This parser is stricter than necessary, but it should allow all
+		# data to be specified that we need it to allow, so instead of
+		# making this parser more complicated (or permissive), see if you
+		# can make the data file follow the expected format.
+		#
+		if ($untrusted =~ m/^
+								$spacere
+								$aryofhashrefre
+								$spacere
+							$/msx)
+		{
+			# If we encountered anything that might cause eval() to perform
+			# variable interpolation, complain and do not eval().  This may
+			# be overly paranoid....
+			if (defined $noevalstr)
+			{
+				my $lineno = scalar(split/\n/, substr($untrusted, 0, $noevalpos));
+				die "\nPossible attempt at variable interpolation in double " .
+					"quoted string in $inputfile, line $lineno: \"$noevalstr\"";
+			}
+
+			# We're treating the input file as a piece of Perl, so we
+			# need to use string eval here. Tell perlcritic we know what
+			# we're doing.
+			#
+			$data = eval $untrusted;	## no critic (ProhibitStringyEval)
+			die $@ if $@;
+		}
+		else
+		{
+			my $lineno = scalar(split/\n/, substr($untrusted, 0, $pos));
+			my $looking = join(" or ", keys %looking);
+			die("\n$inputfile does not match our expected format;\n" .
+				"At line $lineno, looking for $looking\n");
+		}
+	};
+	die $@ if $@;
+
+	return $data;
+}
+
+=pod
+
+=back
+
+=cut
+
+1;
diff --git a/src/backend/commands/createas.c b/src/backend/commands/createas.c
index cc02cf824e..3bcd7a95af 100644
--- a/src/backend/commands/createas.c
+++ b/src/backend/commands/createas.c
@@ -10,7 +10,7 @@
  *
  * Formerly, CTAS was implemented as a variant of SELECT, which led
  * to assorted legacy behaviors that we still try to preserve, notably that
- * we must return a tuples-processed count in the completionTag.  (We no
+ * we must return a tuples-processed count in the QueryCompletion.  (We no
  * longer do that for CTAS ... WITH NO DATA, however.)
  *
  * Portions Copyright (c) 1996-2020, PostgreSQL Global Development Group
@@ -225,7 +225,7 @@ create_ctas_nodata(List *tlist, IntoClause *into)
 ObjectAddress
 ExecCreateTableAs(ParseState *pstate, CreateTableAsStmt *stmt,
 				  ParamListInfo params, QueryEnvironment *queryEnv,
-				  char *completionTag)
+				  QueryCompletion *qc)
 {
 	Query	   *query = castNode(Query, stmt->query);
 	IntoClause *into = stmt->into;
@@ -270,7 +270,7 @@ ExecCreateTableAs(ParseState *pstate, CreateTableAsStmt *stmt,
 		ExecuteStmt *estmt = castNode(ExecuteStmt, query->utilityStmt);
 
 		Assert(!is_matview);	/* excluded by syntax */
-		ExecuteQuery(pstate, estmt, into, params, dest, completionTag);
+		ExecuteQuery(pstate, estmt, into, params, dest, qc);
 
 		/* get object address that intorel_startup saved for us */
 		address = ((DR_intorel *) dest)->reladdr;
@@ -352,11 +352,9 @@ ExecCreateTableAs(ParseState *pstate, CreateTableAsStmt *stmt,
 		/* run the plan to completion */
 		ExecutorRun(queryDesc, ForwardScanDirection, 0L, true);
 
-		/* save the rowcount if we're given a completionTag to fill */
-		if (completionTag)
-			snprintf(completionTag, COMPLETION_TAG_BUFSIZE,
-					 "SELECT " UINT64_FORMAT,
-					 queryDesc->estate->es_processed);
+		/* save the rowcount if we're given a qc to fill */
+		if (qc)
+			SetQueryCompletion(qc, COMMANDTAG_SELECT, queryDesc->estate->es_processed);
 
 		/* get object address that intorel_startup saved for us */
 		address = ((DR_intorel *) dest)->reladdr;
diff --git a/src/backend/commands/event_trigger.c b/src/backend/commands/event_trigger.c
index 71911d4067..7c8415475f 100644
--- a/src/backend/commands/event_trigger.c
+++ b/src/backend/commands/event_trigger.c
@@ -78,59 +78,6 @@ typedef struct
 	bool		supported;
 } event_trigger_support_data;
 
-typedef enum
-{
-	EVENT_TRIGGER_COMMAND_TAG_OK,
-	EVENT_TRIGGER_COMMAND_TAG_NOT_SUPPORTED,
-	EVENT_TRIGGER_COMMAND_TAG_NOT_RECOGNIZED
-} event_trigger_command_tag_check_result;
-
-/* XXX merge this with ObjectTypeMap? */
-static const event_trigger_support_data event_trigger_support[] = {
-	{"ACCESS METHOD", true},
-	{"AGGREGATE", true},
-	{"CAST", true},
-	{"CONSTRAINT", true},
-	{"COLLATION", true},
-	{"CONVERSION", true},
-	{"DATABASE", false},
-	{"DOMAIN", true},
-	{"EXTENSION", true},
-	{"EVENT TRIGGER", false},
-	{"FOREIGN DATA WRAPPER", true},
-	{"FOREIGN TABLE", true},
-	{"FUNCTION", true},
-	{"INDEX", true},
-	{"LANGUAGE", true},
-	{"MATERIALIZED VIEW", true},
-	{"OPERATOR", true},
-	{"OPERATOR CLASS", true},
-	{"OPERATOR FAMILY", true},
-	{"POLICY", true},
-	{"PROCEDURE", true},
-	{"PUBLICATION", true},
-	{"ROLE", false},
-	{"ROUTINE", true},
-	{"RULE", true},
-	{"SCHEMA", true},
-	{"SEQUENCE", true},
-	{"SERVER", true},
-	{"STATISTICS", true},
-	{"SUBSCRIPTION", true},
-	{"TABLE", true},
-	{"TABLESPACE", false},
-	{"TRANSFORM", true},
-	{"TRIGGER", true},
-	{"TEXT SEARCH CONFIGURATION", true},
-	{"TEXT SEARCH DICTIONARY", true},
-	{"TEXT SEARCH PARSER", true},
-	{"TEXT SEARCH TEMPLATE", true},
-	{"TYPE", true},
-	{"USER MAPPING", true},
-	{"VIEW", true},
-	{NULL, false}
-};
-
 /* Support for dropped objects */
 typedef struct SQLDropObject
 {
@@ -150,8 +97,6 @@ typedef struct SQLDropObject
 static void AlterEventTriggerOwner_internal(Relation rel,
 											HeapTuple tup,
 											Oid newOwnerId);
-static event_trigger_command_tag_check_result check_ddl_tag(const char *tag);
-static event_trigger_command_tag_check_result check_table_rewrite_ddl_tag(const char *tag);
 static void error_duplicate_filter_variable(const char *defname);
 static Datum filter_list_to_array(List *filterlist);
 static Oid	insert_event_trigger_tuple(const char *trigname, const char *eventname,
@@ -259,71 +204,23 @@ validate_ddl_tags(const char *filtervar, List *taglist)
 
 	foreach(lc, taglist)
 	{
-		const char *tag = strVal(lfirst(lc));
-		event_trigger_command_tag_check_result result;
+		const char *tagstr = strVal(lfirst(lc));
+		CommandTag	commandTag = GetCommandTagEnum(tagstr);
 
-		result = check_ddl_tag(tag);
-		if (result == EVENT_TRIGGER_COMMAND_TAG_NOT_RECOGNIZED)
+		if (commandTag == COMMANDTAG_UNKNOWN)
 			ereport(ERROR,
 					(errcode(ERRCODE_SYNTAX_ERROR),
 					 errmsg("filter value \"%s\" not recognized for filter variable \"%s\"",
-							tag, filtervar)));
-		if (result == EVENT_TRIGGER_COMMAND_TAG_NOT_SUPPORTED)
+							tagstr, filtervar)));
+		if ( ! command_tag_event_trigger_ok(commandTag))
 			ereport(ERROR,
 					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 			/* translator: %s represents an SQL statement name */
 					 errmsg("event triggers are not supported for %s",
-							tag)));
+							tagstr)));
 	}
 }
 
-static event_trigger_command_tag_check_result
-check_ddl_tag(const char *tag)
-{
-	const char *obtypename;
-	const event_trigger_support_data *etsd;
-
-	/*
-	 * Handle some idiosyncratic special cases.
-	 */
-	if (pg_strcasecmp(tag, "CREATE TABLE AS") == 0 ||
-		pg_strcasecmp(tag, "SELECT INTO") == 0 ||
-		pg_strcasecmp(tag, "REFRESH MATERIALIZED VIEW") == 0 ||
-		pg_strcasecmp(tag, "ALTER DEFAULT PRIVILEGES") == 0 ||
-		pg_strcasecmp(tag, "ALTER LARGE OBJECT") == 0 ||
-		pg_strcasecmp(tag, "COMMENT") == 0 ||
-		pg_strcasecmp(tag, "GRANT") == 0 ||
-		pg_strcasecmp(tag, "REVOKE") == 0 ||
-		pg_strcasecmp(tag, "DROP OWNED") == 0 ||
-		pg_strcasecmp(tag, "IMPORT FOREIGN SCHEMA") == 0 ||
-		pg_strcasecmp(tag, "SECURITY LABEL") == 0)
-		return EVENT_TRIGGER_COMMAND_TAG_OK;
-
-	/*
-	 * Otherwise, command should be CREATE, ALTER, or DROP.
-	 */
-	if (pg_strncasecmp(tag, "CREATE ", 7) == 0)
-		obtypename = tag + 7;
-	else if (pg_strncasecmp(tag, "ALTER ", 6) == 0)
-		obtypename = tag + 6;
-	else if (pg_strncasecmp(tag, "DROP ", 5) == 0)
-		obtypename = tag + 5;
-	else
-		return EVENT_TRIGGER_COMMAND_TAG_NOT_RECOGNIZED;
-
-	/*
-	 * ...and the object type should be something recognizable.
-	 */
-	for (etsd = event_trigger_support; etsd->obtypename != NULL; etsd++)
-		if (pg_strcasecmp(etsd->obtypename, obtypename) == 0)
-			break;
-	if (etsd->obtypename == NULL)
-		return EVENT_TRIGGER_COMMAND_TAG_NOT_RECOGNIZED;
-	if (!etsd->supported)
-		return EVENT_TRIGGER_COMMAND_TAG_NOT_SUPPORTED;
-	return EVENT_TRIGGER_COMMAND_TAG_OK;
-}
-
 /*
  * Validate DDL command tags for event table_rewrite.
  */
@@ -334,29 +231,18 @@ validate_table_rewrite_tags(const char *filtervar, List *taglist)
 
 	foreach(lc, taglist)
 	{
-		const char *tag = strVal(lfirst(lc));
-		event_trigger_command_tag_check_result result;
+		const char *tagstr = strVal(lfirst(lc));
+		CommandTag	commandTag = GetCommandTagEnum(tagstr);
 
-		result = check_table_rewrite_ddl_tag(tag);
-		if (result == EVENT_TRIGGER_COMMAND_TAG_NOT_SUPPORTED)
+		if (! command_tag_table_rewrite_ok(commandTag))
 			ereport(ERROR,
 					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 			/* translator: %s represents an SQL statement name */
 					 errmsg("event triggers are not supported for %s",
-							tag)));
+							tagstr)));
 	}
 }
 
-static event_trigger_command_tag_check_result
-check_table_rewrite_ddl_tag(const char *tag)
-{
-	if (pg_strcasecmp(tag, "ALTER TABLE") == 0 ||
-		pg_strcasecmp(tag, "ALTER TYPE") == 0)
-		return EVENT_TRIGGER_COMMAND_TAG_OK;
-
-	return EVENT_TRIGGER_COMMAND_TAG_NOT_SUPPORTED;
-}
-
 /*
  * Complain about a duplicate filter variable.
  */
@@ -663,7 +549,7 @@ get_event_trigger_oid(const char *trigname, bool missing_ok)
  * tags matching.
  */
 static bool
-filter_event_trigger(const char **tag, EventTriggerCacheItem *item)
+filter_event_trigger(CommandTag tag, EventTriggerCacheItem *item)
 {
 	/*
 	 * Filter by session replication role, knowing that we never see disabled
@@ -681,9 +567,7 @@ filter_event_trigger(const char **tag, EventTriggerCacheItem *item)
 	}
 
 	/* Filter by tags, if any were specified. */
-	if (item->ntags != 0 && bsearch(tag, item->tag,
-									item->ntags, sizeof(char *),
-									pg_qsort_strcmp) == NULL)
+	if (!bms_is_empty(item->tagset) && !bms_is_member(tag, item->tagset))
 		return false;
 
 	/* if we reach that point, we're not filtering out this item */
@@ -700,7 +584,7 @@ EventTriggerCommonSetup(Node *parsetree,
 						EventTriggerEvent event, const char *eventstr,
 						EventTriggerData *trigdata)
 {
-	const char *tag;
+	CommandTag	tag;
 	List	   *cachelist;
 	ListCell   *lc;
 	List	   *runlist = NIL;
@@ -716,25 +600,25 @@ EventTriggerCommonSetup(Node *parsetree,
 	 *
 	 * If this cross-check fails for you, you probably need to either adjust
 	 * standard_ProcessUtility() not to invoke event triggers for the command
-	 * type in question, or you need to adjust check_ddl_tag to accept the
+	 * type in question, or you need to adjust event_trigger_ok to accept the
 	 * relevant command tag.
 	 */
 #ifdef USE_ASSERT_CHECKING
 	{
-		const char *dbgtag;
+		CommandTag	dbgtag;
 
 		dbgtag = CreateCommandTag(parsetree);
 		if (event == EVT_DDLCommandStart ||
 			event == EVT_DDLCommandEnd ||
 			event == EVT_SQLDrop)
 		{
-			if (check_ddl_tag(dbgtag) != EVENT_TRIGGER_COMMAND_TAG_OK)
-				elog(ERROR, "unexpected command tag \"%s\"", dbgtag);
+			if (! command_tag_event_trigger_ok(dbgtag))
+				elog(ERROR, "unexpected command tag \"%s\"", GetCommandTagName(dbgtag));
 		}
 		else if (event == EVT_TableRewrite)
 		{
-			if (check_table_rewrite_ddl_tag(dbgtag) != EVENT_TRIGGER_COMMAND_TAG_OK)
-				elog(ERROR, "unexpected command tag \"%s\"", dbgtag);
+			if (! command_tag_table_rewrite_ok(dbgtag))
+				elog(ERROR, "unexpected command tag \"%s\"", GetCommandTagName(dbgtag));
 		}
 	}
 #endif
@@ -758,7 +642,7 @@ EventTriggerCommonSetup(Node *parsetree,
 	{
 		EventTriggerCacheItem *item = lfirst(lc);
 
-		if (filter_event_trigger(&tag, item))
+		if (filter_event_trigger(tag, item))
 		{
 			/* We must plan to fire this trigger. */
 			runlist = lappend_oid(runlist, item->fnoid);
@@ -2136,7 +2020,7 @@ pg_event_trigger_ddl_commands(PG_FUNCTION_ARGS)
 					/* objsubid */
 					values[i++] = Int32GetDatum(addr.objectSubId);
 					/* command tag */
-					values[i++] = CStringGetTextDatum(CreateCommandTag(cmd->parsetree));
+					values[i++] = CStringGetTextDatum(CreateCommandName(cmd->parsetree));
 					/* object_type */
 					values[i++] = CStringGetTextDatum(type);
 					/* schema */
@@ -2161,7 +2045,7 @@ pg_event_trigger_ddl_commands(PG_FUNCTION_ARGS)
 				/* objsubid */
 				nulls[i++] = true;
 				/* command tag */
-				values[i++] = CStringGetTextDatum(CreateCommandTag(cmd->parsetree));
+				values[i++] = CStringGetTextDatum(CreateCommandName(cmd->parsetree));
 				/* object_type */
 				values[i++] = CStringGetTextDatum(stringify_adefprivs_objtype(cmd->d.defprivs.objtype));
 				/* schema */
diff --git a/src/backend/commands/matview.c b/src/backend/commands/matview.c
index 1ee37c1aeb..c3954f3e24 100644
--- a/src/backend/commands/matview.c
+++ b/src/backend/commands/matview.c
@@ -136,7 +136,7 @@ SetMatViewPopulatedState(Relation relation, bool newstate)
  */
 ObjectAddress
 ExecRefreshMatView(RefreshMatViewStmt *stmt, const char *queryString,
-				   ParamListInfo params, char *completionTag)
+				   ParamListInfo params, QueryCompletion *qc)
 {
 	Oid			matviewOid;
 	Relation	matviewRel;
diff --git a/src/backend/commands/portalcmds.c b/src/backend/commands/portalcmds.c
index 7e5c805a1e..744d79a2e2 100644
--- a/src/backend/commands/portalcmds.c
+++ b/src/backend/commands/portalcmds.c
@@ -106,7 +106,8 @@ PerformCursorOpen(ParseState *pstate, DeclareCursorStmt *cstmt, ParamListInfo pa
 	PortalDefineQuery(portal,
 					  NULL,
 					  queryString,
-					  "SELECT", /* cursor's query is always a SELECT */
+					  COMMANDTAG_SELECT,	/* cursor's query is always a
+											 * SELECT */
 					  list_make1(plan),
 					  NULL);
 
@@ -160,15 +161,14 @@ PerformCursorOpen(ParseState *pstate, DeclareCursorStmt *cstmt, ParamListInfo pa
  *
  *	stmt: parsetree node for command
  *	dest: where to send results
- *	completionTag: points to a buffer of size COMPLETION_TAG_BUFSIZE
- *		in which to store a command completion status string.
+ *	qc: where to store a command completion status data.
  *
- * completionTag may be NULL if caller doesn't want a status string.
+ * qc may be NULL if caller doesn't want status data.
  */
 void
 PerformPortalFetch(FetchStmt *stmt,
 				   DestReceiver *dest,
-				   char *completionTag)
+				   QueryCompletion *qc)
 {
 	Portal		portal;
 	uint64		nprocessed;
@@ -203,10 +203,8 @@ PerformPortalFetch(FetchStmt *stmt,
 								dest);
 
 	/* Return command status if wanted */
-	if (completionTag)
-		snprintf(completionTag, COMPLETION_TAG_BUFSIZE, "%s " UINT64_FORMAT,
-				 stmt->ismove ? "MOVE" : "FETCH",
-				 nprocessed);
+	if (qc)
+		SetQueryCompletion(qc, stmt->ismove ? COMMANDTAG_MOVE : COMMANDTAG_FETCH, nprocessed);
 }
 
 /*
diff --git a/src/backend/commands/prepare.c b/src/backend/commands/prepare.c
index c4e4b6eaec..f917fc9c7a 100644
--- a/src/backend/commands/prepare.c
+++ b/src/backend/commands/prepare.c
@@ -187,7 +187,7 @@ void
 ExecuteQuery(ParseState *pstate,
 			 ExecuteStmt *stmt, IntoClause *intoClause,
 			 ParamListInfo params,
-			 DestReceiver *dest, char *completionTag)
+			 DestReceiver *dest, QueryCompletion *qc)
 {
 	PreparedStatement *entry;
 	CachedPlan *cplan;
@@ -288,7 +288,7 @@ ExecuteQuery(ParseState *pstate,
 	 */
 	PortalStart(portal, paramLI, eflags, GetActiveSnapshot());
 
-	(void) PortalRun(portal, count, false, true, dest, dest, completionTag);
+	(void) PortalRun(portal, count, false, true, dest, dest, qc);
 
 	PortalDrop(portal, false);
 
